﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=11.2
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Private xui As XUI
	Private wmCalendar1 As wmCalendar
	Public rp As RuntimePermissions
	'Public DBFilename As String = "calendar.db"
	'Public DBFileDir As String
	Public DBTableName As String
	Public SQL1 As SQL
	Public Qty As Int
End Sub

Sub Globals
	Private btn_Exit As Button
	Private btn_GetCal As Button
	Private btnSave As Button
	Private lbl_Calendar As Label
	Private txtCalendarID As EditText
	Private txtForward As EditText
	Private txtPrevious As EditText
	Private lblLocalDbase As Label
	Private txtTimeZone As EditText
	Private btnHelp As Button
	Private pnlHelp As Panel
	Private pnlSettings As Panel
	Private btnHelpExit As Button
	Private txtCalendarName As EditText
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("settings")
	pnlHelp.Visible = False
	pnlSettings.Visible = True
	btnSave.Visible = True
	txtCalendarID.Enabled = False
	txtCalendarName.Enabled = False
	wmCalendar1.Initialize
	chkSettings
End Sub

Private Sub chkSettings
	SQL1.Initialize(Starter.DBFolder, Starter.DBFilename, True)
	Qty = Starter.SQL1.ExecQuerySingleResult("SELECT count(ID) FROM settings")
	If Qty=0 Then
		ToastMessageShow("No Calendar saved, please select and Save",True)
		'StartActivity("settings")
	Else
		Private resultset1 As ResultSet
		Private query As String
		SQL1.Initialize(Starter.DBFolder, Starter.DBFilename,True)
		query = "SELECT * FROM settings WHERE Id = '1'"
		resultset1 = SQL1.ExecQuery(query)
		resultset1.Position = 0
		txtCalendarID.Text = resultset1.Getstring("calendarID")
		txtCalendarName.Text = resultset1.GetString("calendar")
		txtPrevious.Text = resultset1.GetString("monthsPrev")
		txtForward.Text = resultset1.GetString("monthsForw")
		lblLocalDbase.Text = resultset1.GetString("localDbase")
		txtTimeZone.Text = resultset1.GetString("timezone")
		ToastMessageShow("Calendar Selected " & txtCalendarName.Text, True)
		If txtPrevious.Text = "" Then txtPrevious.Text = "-1"
		If txtForward.Text = "" Then txtForward.Text = "1"
	End If
	If txtCalendarName.Text = "" Then
		ToastMessageShow("No Calendar Selected ", True)
	Else
		ToastMessageShow("Calendar Selected " & txtCalendarName.Text, True)
	End If
End Sub

Private Sub btnHelp_Click
	pnlSettings.Visible = False
	pnlHelp.Visible = True
End Sub

Private Sub btnHelpExit_Click
	pnlSettings.Visible = True
	pnlHelp.Visible = False
End Sub

Private Sub btn_Exit_Click
	Activity.Finish
End Sub

Private Sub btn_GetCal_Click
	SelectCalendarFromList
End Sub

Private Sub SelectCalendarFromList
	Dim i As Int
	Dim picked As Int
	Dim values As List
	Dim selectedCalendar As String
	Dim allCalendars As List = wmCalendar1.GetAllVisibleCalendars(wmCalendar1.ccon.CALENDAR_DISPLAY_NAME, True)
	values.Initialize
	For i = 0 To (allCalendars.Size - 1)
		Dim oneCalendar As CalendarInfo = allCalendars.Get(i)
		values.Add(oneCalendar.displayName & " - ID=" & oneCalendar.id)
	Next
	values.Add("ditlCalendar - ID=777")
	values.Add("Cancel")
	picked = InputList(values, "Select a Calendar", -1)
	If (picked = (values.Size - 1)) Or (picked < 0) Then Return
	selectedCalendar = values.Get(picked)
	i = selectedCalendar.LastIndexOf("ID=")
	txtCalendarID.Text = selectedCalendar.SubString(i + 3)
	txtCalendarName.Text = selectedCalendar.SubString2(0, i - 3)
End Sub

Private Sub btnSave_Click
	'DBFileDir = rp.GetSafeDirDefaultExternal("")
	SQL1.Initialize(Starter.DBFolder, Starter.DBFilename,True)
	DBTableName = "settings"
	Dim IDNo As Int = 1
	Private maps As List
	Private mp As Map
	If Qty = 0 Then
		maps.Initialize
		mp.Initialize
		mp.Put( "id", IDNo)
		mp.Put( "calendarID", txtCalendarID.Text)
		mp.Put( "calendar", txtCalendarName.Text)
		mp.Put( "monthsPrev", txtPrevious.Text)
		mp.Put( "monthsForw", txtForward.Text)
		mp.Put( "timezone", txtTimeZone.Text)
		maps.Add(mp)
		DBUtils.InsertMaps(SQL1, DBTableName, maps)
		Main.ScalendarID = txtCalendarID.Text
		Main.SCalendar = txtCalendarName.Text
		Main.STimeZone = txtTimeZone.Text
		ToastMessageShow("Settings saved " & txtCalendarName.Text ,True)
		Activity.Finish
	Else
		mp.Initialize
		mp.Put( "id", IDNo)
		DBUtils.UpdateRecord(SQL1,DBTableName, "calendarID", txtCalendarID.Text,mp)
		DBUtils.UpdateRecord(SQL1,DBTableName, "calendar", txtCalendarName.Text,mp)
		DBUtils.UpdateRecord(SQL1,DBTableName, "monthsPrev", txtPrevious.Text, mp)
		DBUtils.UpdateRecord(SQL1,DBTableName, "monthsForw", txtForward.Text, mp)
		DBUtils.UpdateRecord(SQL1,DBTableName, "timezone", txtTimeZone.Text, mp)
		Main.ScalendarID = txtCalendarID.Text
		Main.SCalendar = txtCalendarName.Text
		Main.STimeZone = txtTimeZone.Text
		ToastMessageShow("Settings updated " & txtCalendarName.Text ,True)
		Activity.Finish
	End If
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub
