﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.9
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public SQL1 As SQL
	Public DBFolder As String
	Public DBFilename As String = "calendar.db"
	'Public DBTableName As String
	Public rp As RuntimePermissions
	Public shared As String
End Sub

Sub Service_Create
	DBFolder = rp.GetSafeDirDefaultExternal("")
	'remove next line after testing
	'File.Delete(DBFolder,DBFilename)
	'
	Log("folder and filename " & DBFolder & " " & DBFilename)
	If File.Exists(DBFolder, DBFilename) = False Then
		SQL1.Initialize(DBFolder, DBFilename, True)
		DBUtils.DropTable(SQL1, "settings")
		DBUtils.CreateTable(SQL1, "settings", CreateMap("Id": DBUtils.DB_INTEGER, "calendar": DBUtils.DB_TEXT, "calendarID": DBUtils.DB_INTEGER, "monthsPrev": DBUtils.DB_TEXT, "monthsForw": DBUtils.DB_TEXT, "localDbase": DBUtils.DB_TEXT, "timezone": DBUtils.DB_TEXT), "id")
		DBUtils.DropTable(SQL1, "ditlCalendar")
		DBUtils.CreateTable(SQL1, "ditlCalendar", CreateMap("Id": DBUtils.DB_INTEGER, "event": DBUtils.DB_TEXT, "contact": DBUtils.DB_TEXT, "allday": DBUtils.DB_TEXT, "from": DBUtils.DB_TEXT, "to": DBUtils.DB_TEXT, "location": DBUtils.DB_TEXT, "notes": DBUtils.DB_TEXT), "id")
	Else
		SQL1.Initialize(DBFolder, DBFilename, True)
	End If
	shared = rp.GetSafeDirDefaultExternal("shared")
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
